# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs

__all__ = [
    'GetLiveToolsArpTableResult',
    'AwaitableGetLiveToolsArpTableResult',
    'get_live_tools_arp_table',
    'get_live_tools_arp_table_output',
]

@pulumi.output_type
class GetLiveToolsArpTableResult:
    """
    A collection of values returned by getLiveToolsArpTable.
    """
    def __init__(__self__, arp_table_id=None, id=None, item=None, serial=None):
        if arp_table_id and not isinstance(arp_table_id, str):
            raise TypeError("Expected argument 'arp_table_id' to be a str")
        pulumi.set(__self__, "arp_table_id", arp_table_id)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if item and not isinstance(item, dict):
            raise TypeError("Expected argument 'item' to be a dict")
        pulumi.set(__self__, "item", item)
        if serial and not isinstance(serial, str):
            raise TypeError("Expected argument 'serial' to be a str")
        pulumi.set(__self__, "serial", serial)

    @property
    @pulumi.getter(name="arpTableId")
    def arp_table_id(self) -> str:
        """
        arpTableId path parameter. Arp table ID
        """
        return pulumi.get(self, "arp_table_id")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def item(self) -> 'outputs.GetLiveToolsArpTableItemResult':
        return pulumi.get(self, "item")

    @property
    @pulumi.getter
    def serial(self) -> str:
        """
        serial path parameter.
        """
        return pulumi.get(self, "serial")


class AwaitableGetLiveToolsArpTableResult(GetLiveToolsArpTableResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetLiveToolsArpTableResult(
            arp_table_id=self.arp_table_id,
            id=self.id,
            item=self.item,
            serial=self.serial)


def get_live_tools_arp_table(arp_table_id: Optional[str] = None,
                             serial: Optional[str] = None,
                             opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetLiveToolsArpTableResult:
    """
    ## Example Usage

    ```python
    import pulumi
    import pulumi_meraki as meraki

    example = meraki.devices.get_live_tools_arp_table(arp_table_id="string",
        serial="string")
    pulumi.export("merakiDevicesLiveToolsArpTableExample", example.item)
    ```


    :param str arp_table_id: arpTableId path parameter. Arp table ID
    :param str serial: serial path parameter.
    """
    __args__ = dict()
    __args__['arpTableId'] = arp_table_id
    __args__['serial'] = serial
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('meraki:devices/getLiveToolsArpTable:getLiveToolsArpTable', __args__, opts=opts, typ=GetLiveToolsArpTableResult).value

    return AwaitableGetLiveToolsArpTableResult(
        arp_table_id=pulumi.get(__ret__, 'arp_table_id'),
        id=pulumi.get(__ret__, 'id'),
        item=pulumi.get(__ret__, 'item'),
        serial=pulumi.get(__ret__, 'serial'))
def get_live_tools_arp_table_output(arp_table_id: Optional[pulumi.Input[str]] = None,
                                    serial: Optional[pulumi.Input[str]] = None,
                                    opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetLiveToolsArpTableResult]:
    """
    ## Example Usage

    ```python
    import pulumi
    import pulumi_meraki as meraki

    example = meraki.devices.get_live_tools_arp_table(arp_table_id="string",
        serial="string")
    pulumi.export("merakiDevicesLiveToolsArpTableExample", example.item)
    ```


    :param str arp_table_id: arpTableId path parameter. Arp table ID
    :param str serial: serial path parameter.
    """
    __args__ = dict()
    __args__['arpTableId'] = arp_table_id
    __args__['serial'] = serial
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('meraki:devices/getLiveToolsArpTable:getLiveToolsArpTable', __args__, opts=opts, typ=GetLiveToolsArpTableResult)
    return __ret__.apply(lambda __response__: GetLiveToolsArpTableResult(
        arp_table_id=pulumi.get(__response__, 'arp_table_id'),
        id=pulumi.get(__response__, 'id'),
        item=pulumi.get(__response__, 'item'),
        serial=pulumi.get(__response__, 'serial')))
