# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs

__all__ = [
    'GetLiveToolsWakeOnLanResult',
    'AwaitableGetLiveToolsWakeOnLanResult',
    'get_live_tools_wake_on_lan',
    'get_live_tools_wake_on_lan_output',
]

@pulumi.output_type
class GetLiveToolsWakeOnLanResult:
    """
    A collection of values returned by getLiveToolsWakeOnLan.
    """
    def __init__(__self__, id=None, item=None, serial=None, wake_on_lan_id=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if item and not isinstance(item, dict):
            raise TypeError("Expected argument 'item' to be a dict")
        pulumi.set(__self__, "item", item)
        if serial and not isinstance(serial, str):
            raise TypeError("Expected argument 'serial' to be a str")
        pulumi.set(__self__, "serial", serial)
        if wake_on_lan_id and not isinstance(wake_on_lan_id, str):
            raise TypeError("Expected argument 'wake_on_lan_id' to be a str")
        pulumi.set(__self__, "wake_on_lan_id", wake_on_lan_id)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def item(self) -> 'outputs.GetLiveToolsWakeOnLanItemResult':
        return pulumi.get(self, "item")

    @property
    @pulumi.getter
    def serial(self) -> str:
        """
        serial path parameter.
        """
        return pulumi.get(self, "serial")

    @property
    @pulumi.getter(name="wakeOnLanId")
    def wake_on_lan_id(self) -> str:
        """
        wakeOnLanId path parameter. Wake on lan ID
        """
        return pulumi.get(self, "wake_on_lan_id")


class AwaitableGetLiveToolsWakeOnLanResult(GetLiveToolsWakeOnLanResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetLiveToolsWakeOnLanResult(
            id=self.id,
            item=self.item,
            serial=self.serial,
            wake_on_lan_id=self.wake_on_lan_id)


def get_live_tools_wake_on_lan(serial: Optional[str] = None,
                               wake_on_lan_id: Optional[str] = None,
                               opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetLiveToolsWakeOnLanResult:
    """
    ## Example Usage

    ```python
    import pulumi
    import pulumi_meraki as meraki

    example = meraki.devices.get_live_tools_wake_on_lan(serial="string",
        wake_on_lan_id="string")
    pulumi.export("merakiDevicesLiveToolsWakeOnLanExample", example.item)
    ```


    :param str serial: serial path parameter.
    :param str wake_on_lan_id: wakeOnLanId path parameter. Wake on lan ID
    """
    __args__ = dict()
    __args__['serial'] = serial
    __args__['wakeOnLanId'] = wake_on_lan_id
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('meraki:devices/getLiveToolsWakeOnLan:getLiveToolsWakeOnLan', __args__, opts=opts, typ=GetLiveToolsWakeOnLanResult).value

    return AwaitableGetLiveToolsWakeOnLanResult(
        id=pulumi.get(__ret__, 'id'),
        item=pulumi.get(__ret__, 'item'),
        serial=pulumi.get(__ret__, 'serial'),
        wake_on_lan_id=pulumi.get(__ret__, 'wake_on_lan_id'))
def get_live_tools_wake_on_lan_output(serial: Optional[pulumi.Input[str]] = None,
                                      wake_on_lan_id: Optional[pulumi.Input[str]] = None,
                                      opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetLiveToolsWakeOnLanResult]:
    """
    ## Example Usage

    ```python
    import pulumi
    import pulumi_meraki as meraki

    example = meraki.devices.get_live_tools_wake_on_lan(serial="string",
        wake_on_lan_id="string")
    pulumi.export("merakiDevicesLiveToolsWakeOnLanExample", example.item)
    ```


    :param str serial: serial path parameter.
    :param str wake_on_lan_id: wakeOnLanId path parameter. Wake on lan ID
    """
    __args__ = dict()
    __args__['serial'] = serial
    __args__['wakeOnLanId'] = wake_on_lan_id
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('meraki:devices/getLiveToolsWakeOnLan:getLiveToolsWakeOnLan', __args__, opts=opts, typ=GetLiveToolsWakeOnLanResult)
    return __ret__.apply(lambda __response__: GetLiveToolsWakeOnLanResult(
        id=pulumi.get(__response__, 'id'),
        item=pulumi.get(__response__, 'item'),
        serial=pulumi.get(__response__, 'serial'),
        wake_on_lan_id=pulumi.get(__response__, 'wake_on_lan_id')))
