# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs
from ._inputs import *

__all__ = ['ApplianceConnectivityMonitoringDestinationsArgs', 'ApplianceConnectivityMonitoringDestinations']

@pulumi.input_type
class ApplianceConnectivityMonitoringDestinationsArgs:
    def __init__(__self__, *,
                 network_id: pulumi.Input[str],
                 destinations: Optional[pulumi.Input[Sequence[pulumi.Input['ApplianceConnectivityMonitoringDestinationsDestinationArgs']]]] = None):
        """
        The set of arguments for constructing a ApplianceConnectivityMonitoringDestinations resource.
        :param pulumi.Input[str] network_id: networkId path parameter. Network ID
        :param pulumi.Input[Sequence[pulumi.Input['ApplianceConnectivityMonitoringDestinationsDestinationArgs']]] destinations: The list of connectivity monitoring destinations
        """
        pulumi.set(__self__, "network_id", network_id)
        if destinations is not None:
            pulumi.set(__self__, "destinations", destinations)

    @property
    @pulumi.getter(name="networkId")
    def network_id(self) -> pulumi.Input[str]:
        """
        networkId path parameter. Network ID
        """
        return pulumi.get(self, "network_id")

    @network_id.setter
    def network_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "network_id", value)

    @property
    @pulumi.getter
    def destinations(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['ApplianceConnectivityMonitoringDestinationsDestinationArgs']]]]:
        """
        The list of connectivity monitoring destinations
        """
        return pulumi.get(self, "destinations")

    @destinations.setter
    def destinations(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['ApplianceConnectivityMonitoringDestinationsDestinationArgs']]]]):
        pulumi.set(self, "destinations", value)


@pulumi.input_type
class _ApplianceConnectivityMonitoringDestinationsState:
    def __init__(__self__, *,
                 destinations: Optional[pulumi.Input[Sequence[pulumi.Input['ApplianceConnectivityMonitoringDestinationsDestinationArgs']]]] = None,
                 network_id: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering ApplianceConnectivityMonitoringDestinations resources.
        :param pulumi.Input[Sequence[pulumi.Input['ApplianceConnectivityMonitoringDestinationsDestinationArgs']]] destinations: The list of connectivity monitoring destinations
        :param pulumi.Input[str] network_id: networkId path parameter. Network ID
        """
        if destinations is not None:
            pulumi.set(__self__, "destinations", destinations)
        if network_id is not None:
            pulumi.set(__self__, "network_id", network_id)

    @property
    @pulumi.getter
    def destinations(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['ApplianceConnectivityMonitoringDestinationsDestinationArgs']]]]:
        """
        The list of connectivity monitoring destinations
        """
        return pulumi.get(self, "destinations")

    @destinations.setter
    def destinations(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['ApplianceConnectivityMonitoringDestinationsDestinationArgs']]]]):
        pulumi.set(self, "destinations", value)

    @property
    @pulumi.getter(name="networkId")
    def network_id(self) -> Optional[pulumi.Input[str]]:
        """
        networkId path parameter. Network ID
        """
        return pulumi.get(self, "network_id")

    @network_id.setter
    def network_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "network_id", value)


class ApplianceConnectivityMonitoringDestinations(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 destinations: Optional[pulumi.Input[Sequence[pulumi.Input[Union['ApplianceConnectivityMonitoringDestinationsDestinationArgs', 'ApplianceConnectivityMonitoringDestinationsDestinationArgsDict']]]]] = None,
                 network_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        ## Example Usage

        ```python
        import pulumi
        import pulumi_meraki as meraki

        example = meraki.networks.ApplianceConnectivityMonitoringDestinations("example",
            destinations=[{
                "default": False,
                "description": "Google",
                "ip": "8.8.8.8",
            }],
            network_id="string")
        pulumi.export("merakiNetworksApplianceConnectivityMonitoringDestinationsExample", example)
        ```

        ## Import

        ```sh
        $ pulumi import meraki:networks/applianceConnectivityMonitoringDestinations:ApplianceConnectivityMonitoringDestinations example "network_id"
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[Sequence[pulumi.Input[Union['ApplianceConnectivityMonitoringDestinationsDestinationArgs', 'ApplianceConnectivityMonitoringDestinationsDestinationArgsDict']]]] destinations: The list of connectivity monitoring destinations
        :param pulumi.Input[str] network_id: networkId path parameter. Network ID
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: ApplianceConnectivityMonitoringDestinationsArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        ## Example Usage

        ```python
        import pulumi
        import pulumi_meraki as meraki

        example = meraki.networks.ApplianceConnectivityMonitoringDestinations("example",
            destinations=[{
                "default": False,
                "description": "Google",
                "ip": "8.8.8.8",
            }],
            network_id="string")
        pulumi.export("merakiNetworksApplianceConnectivityMonitoringDestinationsExample", example)
        ```

        ## Import

        ```sh
        $ pulumi import meraki:networks/applianceConnectivityMonitoringDestinations:ApplianceConnectivityMonitoringDestinations example "network_id"
        ```

        :param str resource_name: The name of the resource.
        :param ApplianceConnectivityMonitoringDestinationsArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(ApplianceConnectivityMonitoringDestinationsArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 destinations: Optional[pulumi.Input[Sequence[pulumi.Input[Union['ApplianceConnectivityMonitoringDestinationsDestinationArgs', 'ApplianceConnectivityMonitoringDestinationsDestinationArgsDict']]]]] = None,
                 network_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = ApplianceConnectivityMonitoringDestinationsArgs.__new__(ApplianceConnectivityMonitoringDestinationsArgs)

            __props__.__dict__["destinations"] = destinations
            if network_id is None and not opts.urn:
                raise TypeError("Missing required property 'network_id'")
            __props__.__dict__["network_id"] = network_id
        super(ApplianceConnectivityMonitoringDestinations, __self__).__init__(
            'meraki:networks/applianceConnectivityMonitoringDestinations:ApplianceConnectivityMonitoringDestinations',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            destinations: Optional[pulumi.Input[Sequence[pulumi.Input[Union['ApplianceConnectivityMonitoringDestinationsDestinationArgs', 'ApplianceConnectivityMonitoringDestinationsDestinationArgsDict']]]]] = None,
            network_id: Optional[pulumi.Input[str]] = None) -> 'ApplianceConnectivityMonitoringDestinations':
        """
        Get an existing ApplianceConnectivityMonitoringDestinations resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[Sequence[pulumi.Input[Union['ApplianceConnectivityMonitoringDestinationsDestinationArgs', 'ApplianceConnectivityMonitoringDestinationsDestinationArgsDict']]]] destinations: The list of connectivity monitoring destinations
        :param pulumi.Input[str] network_id: networkId path parameter. Network ID
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _ApplianceConnectivityMonitoringDestinationsState.__new__(_ApplianceConnectivityMonitoringDestinationsState)

        __props__.__dict__["destinations"] = destinations
        __props__.__dict__["network_id"] = network_id
        return ApplianceConnectivityMonitoringDestinations(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def destinations(self) -> pulumi.Output[Sequence['outputs.ApplianceConnectivityMonitoringDestinationsDestination']]:
        """
        The list of connectivity monitoring destinations
        """
        return pulumi.get(self, "destinations")

    @property
    @pulumi.getter(name="networkId")
    def network_id(self) -> pulumi.Output[str]:
        """
        networkId path parameter. Network ID
        """
        return pulumi.get(self, "network_id")

