# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs
from ._inputs import *

__all__ = ['ApplianceTrafficShapingArgs', 'ApplianceTrafficShaping']

@pulumi.input_type
class ApplianceTrafficShapingArgs:
    def __init__(__self__, *,
                 network_id: pulumi.Input[str],
                 global_bandwidth_limits: Optional[pulumi.Input['ApplianceTrafficShapingGlobalBandwidthLimitsArgs']] = None):
        """
        The set of arguments for constructing a ApplianceTrafficShaping resource.
        :param pulumi.Input[str] network_id: networkId path parameter. Network ID
        :param pulumi.Input['ApplianceTrafficShapingGlobalBandwidthLimitsArgs'] global_bandwidth_limits: Global per-client bandwidth limit
        """
        pulumi.set(__self__, "network_id", network_id)
        if global_bandwidth_limits is not None:
            pulumi.set(__self__, "global_bandwidth_limits", global_bandwidth_limits)

    @property
    @pulumi.getter(name="networkId")
    def network_id(self) -> pulumi.Input[str]:
        """
        networkId path parameter. Network ID
        """
        return pulumi.get(self, "network_id")

    @network_id.setter
    def network_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "network_id", value)

    @property
    @pulumi.getter(name="globalBandwidthLimits")
    def global_bandwidth_limits(self) -> Optional[pulumi.Input['ApplianceTrafficShapingGlobalBandwidthLimitsArgs']]:
        """
        Global per-client bandwidth limit
        """
        return pulumi.get(self, "global_bandwidth_limits")

    @global_bandwidth_limits.setter
    def global_bandwidth_limits(self, value: Optional[pulumi.Input['ApplianceTrafficShapingGlobalBandwidthLimitsArgs']]):
        pulumi.set(self, "global_bandwidth_limits", value)


@pulumi.input_type
class _ApplianceTrafficShapingState:
    def __init__(__self__, *,
                 global_bandwidth_limits: Optional[pulumi.Input['ApplianceTrafficShapingGlobalBandwidthLimitsArgs']] = None,
                 network_id: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering ApplianceTrafficShaping resources.
        :param pulumi.Input['ApplianceTrafficShapingGlobalBandwidthLimitsArgs'] global_bandwidth_limits: Global per-client bandwidth limit
        :param pulumi.Input[str] network_id: networkId path parameter. Network ID
        """
        if global_bandwidth_limits is not None:
            pulumi.set(__self__, "global_bandwidth_limits", global_bandwidth_limits)
        if network_id is not None:
            pulumi.set(__self__, "network_id", network_id)

    @property
    @pulumi.getter(name="globalBandwidthLimits")
    def global_bandwidth_limits(self) -> Optional[pulumi.Input['ApplianceTrafficShapingGlobalBandwidthLimitsArgs']]:
        """
        Global per-client bandwidth limit
        """
        return pulumi.get(self, "global_bandwidth_limits")

    @global_bandwidth_limits.setter
    def global_bandwidth_limits(self, value: Optional[pulumi.Input['ApplianceTrafficShapingGlobalBandwidthLimitsArgs']]):
        pulumi.set(self, "global_bandwidth_limits", value)

    @property
    @pulumi.getter(name="networkId")
    def network_id(self) -> Optional[pulumi.Input[str]]:
        """
        networkId path parameter. Network ID
        """
        return pulumi.get(self, "network_id")

    @network_id.setter
    def network_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "network_id", value)


class ApplianceTrafficShaping(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 global_bandwidth_limits: Optional[pulumi.Input[Union['ApplianceTrafficShapingGlobalBandwidthLimitsArgs', 'ApplianceTrafficShapingGlobalBandwidthLimitsArgsDict']]] = None,
                 network_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        ## Example Usage

        ## Import

        ```sh
        $ pulumi import meraki:networks/applianceTrafficShaping:ApplianceTrafficShaping example "network_id"
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[Union['ApplianceTrafficShapingGlobalBandwidthLimitsArgs', 'ApplianceTrafficShapingGlobalBandwidthLimitsArgsDict']] global_bandwidth_limits: Global per-client bandwidth limit
        :param pulumi.Input[str] network_id: networkId path parameter. Network ID
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: ApplianceTrafficShapingArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        ## Example Usage

        ## Import

        ```sh
        $ pulumi import meraki:networks/applianceTrafficShaping:ApplianceTrafficShaping example "network_id"
        ```

        :param str resource_name: The name of the resource.
        :param ApplianceTrafficShapingArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(ApplianceTrafficShapingArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 global_bandwidth_limits: Optional[pulumi.Input[Union['ApplianceTrafficShapingGlobalBandwidthLimitsArgs', 'ApplianceTrafficShapingGlobalBandwidthLimitsArgsDict']]] = None,
                 network_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = ApplianceTrafficShapingArgs.__new__(ApplianceTrafficShapingArgs)

            __props__.__dict__["global_bandwidth_limits"] = global_bandwidth_limits
            if network_id is None and not opts.urn:
                raise TypeError("Missing required property 'network_id'")
            __props__.__dict__["network_id"] = network_id
        super(ApplianceTrafficShaping, __self__).__init__(
            'meraki:networks/applianceTrafficShaping:ApplianceTrafficShaping',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            global_bandwidth_limits: Optional[pulumi.Input[Union['ApplianceTrafficShapingGlobalBandwidthLimitsArgs', 'ApplianceTrafficShapingGlobalBandwidthLimitsArgsDict']]] = None,
            network_id: Optional[pulumi.Input[str]] = None) -> 'ApplianceTrafficShaping':
        """
        Get an existing ApplianceTrafficShaping resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[Union['ApplianceTrafficShapingGlobalBandwidthLimitsArgs', 'ApplianceTrafficShapingGlobalBandwidthLimitsArgsDict']] global_bandwidth_limits: Global per-client bandwidth limit
        :param pulumi.Input[str] network_id: networkId path parameter. Network ID
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _ApplianceTrafficShapingState.__new__(_ApplianceTrafficShapingState)

        __props__.__dict__["global_bandwidth_limits"] = global_bandwidth_limits
        __props__.__dict__["network_id"] = network_id
        return ApplianceTrafficShaping(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="globalBandwidthLimits")
    def global_bandwidth_limits(self) -> pulumi.Output['outputs.ApplianceTrafficShapingGlobalBandwidthLimits']:
        """
        Global per-client bandwidth limit
        """
        return pulumi.get(self, "global_bandwidth_limits")

    @property
    @pulumi.getter(name="networkId")
    def network_id(self) -> pulumi.Output[str]:
        """
        networkId path parameter. Network ID
        """
        return pulumi.get(self, "network_id")

