# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs

__all__ = [
    'GetApplianceRfProfilesResult',
    'AwaitableGetApplianceRfProfilesResult',
    'get_appliance_rf_profiles',
    'get_appliance_rf_profiles_output',
]

@pulumi.output_type
class GetApplianceRfProfilesResult:
    """
    A collection of values returned by getApplianceRfProfiles.
    """
    def __init__(__self__, id=None, item=None, network_id=None, rf_profile_id=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if item and not isinstance(item, dict):
            raise TypeError("Expected argument 'item' to be a dict")
        pulumi.set(__self__, "item", item)
        if network_id and not isinstance(network_id, str):
            raise TypeError("Expected argument 'network_id' to be a str")
        pulumi.set(__self__, "network_id", network_id)
        if rf_profile_id and not isinstance(rf_profile_id, str):
            raise TypeError("Expected argument 'rf_profile_id' to be a str")
        pulumi.set(__self__, "rf_profile_id", rf_profile_id)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def item(self) -> 'outputs.GetApplianceRfProfilesItemResult':
        return pulumi.get(self, "item")

    @property
    @pulumi.getter(name="networkId")
    def network_id(self) -> Optional[str]:
        """
        networkId path parameter. Network ID
        """
        return pulumi.get(self, "network_id")

    @property
    @pulumi.getter(name="rfProfileId")
    def rf_profile_id(self) -> Optional[str]:
        """
        rfProfileId path parameter. Rf profile ID
        """
        return pulumi.get(self, "rf_profile_id")


class AwaitableGetApplianceRfProfilesResult(GetApplianceRfProfilesResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetApplianceRfProfilesResult(
            id=self.id,
            item=self.item,
            network_id=self.network_id,
            rf_profile_id=self.rf_profile_id)


def get_appliance_rf_profiles(network_id: Optional[str] = None,
                              rf_profile_id: Optional[str] = None,
                              opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetApplianceRfProfilesResult:
    """
    ## Example Usage

    ```python
    import pulumi
    import pulumi_meraki as meraki

    example = meraki.networks.get_appliance_rf_profiles(network_id="string")
    pulumi.export("merakiNetworksApplianceRfProfilesExample", example.item)
    ```


    :param str network_id: networkId path parameter. Network ID
    :param str rf_profile_id: rfProfileId path parameter. Rf profile ID
    """
    __args__ = dict()
    __args__['networkId'] = network_id
    __args__['rfProfileId'] = rf_profile_id
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('meraki:networks/getApplianceRfProfiles:getApplianceRfProfiles', __args__, opts=opts, typ=GetApplianceRfProfilesResult).value

    return AwaitableGetApplianceRfProfilesResult(
        id=pulumi.get(__ret__, 'id'),
        item=pulumi.get(__ret__, 'item'),
        network_id=pulumi.get(__ret__, 'network_id'),
        rf_profile_id=pulumi.get(__ret__, 'rf_profile_id'))
def get_appliance_rf_profiles_output(network_id: Optional[pulumi.Input[Optional[str]]] = None,
                                     rf_profile_id: Optional[pulumi.Input[Optional[str]]] = None,
                                     opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetApplianceRfProfilesResult]:
    """
    ## Example Usage

    ```python
    import pulumi
    import pulumi_meraki as meraki

    example = meraki.networks.get_appliance_rf_profiles(network_id="string")
    pulumi.export("merakiNetworksApplianceRfProfilesExample", example.item)
    ```


    :param str network_id: networkId path parameter. Network ID
    :param str rf_profile_id: rfProfileId path parameter. Rf profile ID
    """
    __args__ = dict()
    __args__['networkId'] = network_id
    __args__['rfProfileId'] = rf_profile_id
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('meraki:networks/getApplianceRfProfiles:getApplianceRfProfiles', __args__, opts=opts, typ=GetApplianceRfProfilesResult)
    return __ret__.apply(lambda __response__: GetApplianceRfProfilesResult(
        id=pulumi.get(__response__, 'id'),
        item=pulumi.get(__response__, 'item'),
        network_id=pulumi.get(__response__, 'network_id'),
        rf_profile_id=pulumi.get(__response__, 'rf_profile_id')))
