# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs

__all__ = [
    'GetCameraQualityRetentionProfilesResult',
    'AwaitableGetCameraQualityRetentionProfilesResult',
    'get_camera_quality_retention_profiles',
    'get_camera_quality_retention_profiles_output',
]

@pulumi.output_type
class GetCameraQualityRetentionProfilesResult:
    """
    A collection of values returned by getCameraQualityRetentionProfiles.
    """
    def __init__(__self__, id=None, item=None, items=None, network_id=None, quality_retention_profile_id=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if item and not isinstance(item, dict):
            raise TypeError("Expected argument 'item' to be a dict")
        pulumi.set(__self__, "item", item)
        if items and not isinstance(items, list):
            raise TypeError("Expected argument 'items' to be a list")
        pulumi.set(__self__, "items", items)
        if network_id and not isinstance(network_id, str):
            raise TypeError("Expected argument 'network_id' to be a str")
        pulumi.set(__self__, "network_id", network_id)
        if quality_retention_profile_id and not isinstance(quality_retention_profile_id, str):
            raise TypeError("Expected argument 'quality_retention_profile_id' to be a str")
        pulumi.set(__self__, "quality_retention_profile_id", quality_retention_profile_id)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def item(self) -> 'outputs.GetCameraQualityRetentionProfilesItemResult':
        return pulumi.get(self, "item")

    @property
    @pulumi.getter
    def items(self) -> Sequence['outputs.GetCameraQualityRetentionProfilesItemResult']:
        """
        Array of ResponseCameraGetNetworkCameraQualityRetentionProfiles
        """
        return pulumi.get(self, "items")

    @property
    @pulumi.getter(name="networkId")
    def network_id(self) -> Optional[str]:
        """
        networkId path parameter. Network ID
        """
        return pulumi.get(self, "network_id")

    @property
    @pulumi.getter(name="qualityRetentionProfileId")
    def quality_retention_profile_id(self) -> Optional[str]:
        """
        qualityRetentionProfileId path parameter. Quality retention profile ID
        """
        return pulumi.get(self, "quality_retention_profile_id")


class AwaitableGetCameraQualityRetentionProfilesResult(GetCameraQualityRetentionProfilesResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetCameraQualityRetentionProfilesResult(
            id=self.id,
            item=self.item,
            items=self.items,
            network_id=self.network_id,
            quality_retention_profile_id=self.quality_retention_profile_id)


def get_camera_quality_retention_profiles(network_id: Optional[str] = None,
                                          quality_retention_profile_id: Optional[str] = None,
                                          opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetCameraQualityRetentionProfilesResult:
    """
    ## Example Usage


    :param str network_id: networkId path parameter. Network ID
    :param str quality_retention_profile_id: qualityRetentionProfileId path parameter. Quality retention profile ID
    """
    __args__ = dict()
    __args__['networkId'] = network_id
    __args__['qualityRetentionProfileId'] = quality_retention_profile_id
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('meraki:networks/getCameraQualityRetentionProfiles:getCameraQualityRetentionProfiles', __args__, opts=opts, typ=GetCameraQualityRetentionProfilesResult).value

    return AwaitableGetCameraQualityRetentionProfilesResult(
        id=pulumi.get(__ret__, 'id'),
        item=pulumi.get(__ret__, 'item'),
        items=pulumi.get(__ret__, 'items'),
        network_id=pulumi.get(__ret__, 'network_id'),
        quality_retention_profile_id=pulumi.get(__ret__, 'quality_retention_profile_id'))
def get_camera_quality_retention_profiles_output(network_id: Optional[pulumi.Input[Optional[str]]] = None,
                                                 quality_retention_profile_id: Optional[pulumi.Input[Optional[str]]] = None,
                                                 opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetCameraQualityRetentionProfilesResult]:
    """
    ## Example Usage


    :param str network_id: networkId path parameter. Network ID
    :param str quality_retention_profile_id: qualityRetentionProfileId path parameter. Quality retention profile ID
    """
    __args__ = dict()
    __args__['networkId'] = network_id
    __args__['qualityRetentionProfileId'] = quality_retention_profile_id
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('meraki:networks/getCameraQualityRetentionProfiles:getCameraQualityRetentionProfiles', __args__, opts=opts, typ=GetCameraQualityRetentionProfilesResult)
    return __ret__.apply(lambda __response__: GetCameraQualityRetentionProfilesResult(
        id=pulumi.get(__response__, 'id'),
        item=pulumi.get(__response__, 'item'),
        items=pulumi.get(__response__, 'items'),
        network_id=pulumi.get(__response__, 'network_id'),
        quality_retention_profile_id=pulumi.get(__response__, 'quality_retention_profile_id')))
