# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs

__all__ = [
    'GetSmUsersSoftwaresResult',
    'AwaitableGetSmUsersSoftwaresResult',
    'get_sm_users_softwares',
    'get_sm_users_softwares_output',
]

@pulumi.output_type
class GetSmUsersSoftwaresResult:
    """
    A collection of values returned by getSmUsersSoftwares.
    """
    def __init__(__self__, id=None, items=None, network_id=None, user_id=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if items and not isinstance(items, list):
            raise TypeError("Expected argument 'items' to be a list")
        pulumi.set(__self__, "items", items)
        if network_id and not isinstance(network_id, str):
            raise TypeError("Expected argument 'network_id' to be a str")
        pulumi.set(__self__, "network_id", network_id)
        if user_id and not isinstance(user_id, str):
            raise TypeError("Expected argument 'user_id' to be a str")
        pulumi.set(__self__, "user_id", user_id)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def items(self) -> Sequence['outputs.GetSmUsersSoftwaresItemResult']:
        """
        Array of ResponseSmGetNetworkSmUserSoftwares
        """
        return pulumi.get(self, "items")

    @property
    @pulumi.getter(name="networkId")
    def network_id(self) -> str:
        """
        networkId path parameter. Network ID
        """
        return pulumi.get(self, "network_id")

    @property
    @pulumi.getter(name="userId")
    def user_id(self) -> str:
        """
        userId path parameter. User ID
        """
        return pulumi.get(self, "user_id")


class AwaitableGetSmUsersSoftwaresResult(GetSmUsersSoftwaresResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetSmUsersSoftwaresResult(
            id=self.id,
            items=self.items,
            network_id=self.network_id,
            user_id=self.user_id)


def get_sm_users_softwares(network_id: Optional[str] = None,
                           user_id: Optional[str] = None,
                           opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetSmUsersSoftwaresResult:
    """
    ## Example Usage

    ```python
    import pulumi
    import pulumi_meraki as meraki

    example = meraki.networks.get_sm_users_softwares(network_id="string",
        user_id="string")
    pulumi.export("merakiNetworksSmUsersSoftwaresExample", example.items)
    ```


    :param str network_id: networkId path parameter. Network ID
    :param str user_id: userId path parameter. User ID
    """
    __args__ = dict()
    __args__['networkId'] = network_id
    __args__['userId'] = user_id
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('meraki:networks/getSmUsersSoftwares:getSmUsersSoftwares', __args__, opts=opts, typ=GetSmUsersSoftwaresResult).value

    return AwaitableGetSmUsersSoftwaresResult(
        id=pulumi.get(__ret__, 'id'),
        items=pulumi.get(__ret__, 'items'),
        network_id=pulumi.get(__ret__, 'network_id'),
        user_id=pulumi.get(__ret__, 'user_id'))
def get_sm_users_softwares_output(network_id: Optional[pulumi.Input[str]] = None,
                                  user_id: Optional[pulumi.Input[str]] = None,
                                  opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetSmUsersSoftwaresResult]:
    """
    ## Example Usage

    ```python
    import pulumi
    import pulumi_meraki as meraki

    example = meraki.networks.get_sm_users_softwares(network_id="string",
        user_id="string")
    pulumi.export("merakiNetworksSmUsersSoftwaresExample", example.items)
    ```


    :param str network_id: networkId path parameter. Network ID
    :param str user_id: userId path parameter. User ID
    """
    __args__ = dict()
    __args__['networkId'] = network_id
    __args__['userId'] = user_id
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('meraki:networks/getSmUsersSoftwares:getSmUsersSoftwares', __args__, opts=opts, typ=GetSmUsersSoftwaresResult)
    return __ret__.apply(lambda __response__: GetSmUsersSoftwaresResult(
        id=pulumi.get(__response__, 'id'),
        items=pulumi.get(__response__, 'items'),
        network_id=pulumi.get(__response__, 'network_id'),
        user_id=pulumi.get(__response__, 'user_id')))
