# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs

__all__ = [
    'GetSwitchRoutingMulticastRendezvousPointsResult',
    'AwaitableGetSwitchRoutingMulticastRendezvousPointsResult',
    'get_switch_routing_multicast_rendezvous_points',
    'get_switch_routing_multicast_rendezvous_points_output',
]

@pulumi.output_type
class GetSwitchRoutingMulticastRendezvousPointsResult:
    """
    A collection of values returned by getSwitchRoutingMulticastRendezvousPoints.
    """
    def __init__(__self__, id=None, item=None, items=None, network_id=None, rendezvous_point_id=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if item and not isinstance(item, dict):
            raise TypeError("Expected argument 'item' to be a dict")
        pulumi.set(__self__, "item", item)
        if items and not isinstance(items, list):
            raise TypeError("Expected argument 'items' to be a list")
        pulumi.set(__self__, "items", items)
        if network_id and not isinstance(network_id, str):
            raise TypeError("Expected argument 'network_id' to be a str")
        pulumi.set(__self__, "network_id", network_id)
        if rendezvous_point_id and not isinstance(rendezvous_point_id, str):
            raise TypeError("Expected argument 'rendezvous_point_id' to be a str")
        pulumi.set(__self__, "rendezvous_point_id", rendezvous_point_id)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def item(self) -> 'outputs.GetSwitchRoutingMulticastRendezvousPointsItemResult':
        return pulumi.get(self, "item")

    @property
    @pulumi.getter
    def items(self) -> Sequence['outputs.GetSwitchRoutingMulticastRendezvousPointsItemResult']:
        """
        Array of ResponseSwitchGetNetworkSwitchRoutingMulticastRendezvousPoints
        """
        return pulumi.get(self, "items")

    @property
    @pulumi.getter(name="networkId")
    def network_id(self) -> Optional[str]:
        """
        networkId path parameter. Network ID
        """
        return pulumi.get(self, "network_id")

    @property
    @pulumi.getter(name="rendezvousPointId")
    def rendezvous_point_id(self) -> Optional[str]:
        """
        rendezvousPointId path parameter. Rendezvous point ID
        """
        return pulumi.get(self, "rendezvous_point_id")


class AwaitableGetSwitchRoutingMulticastRendezvousPointsResult(GetSwitchRoutingMulticastRendezvousPointsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetSwitchRoutingMulticastRendezvousPointsResult(
            id=self.id,
            item=self.item,
            items=self.items,
            network_id=self.network_id,
            rendezvous_point_id=self.rendezvous_point_id)


def get_switch_routing_multicast_rendezvous_points(network_id: Optional[str] = None,
                                                   rendezvous_point_id: Optional[str] = None,
                                                   opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetSwitchRoutingMulticastRendezvousPointsResult:
    """
    ## Example Usage


    :param str network_id: networkId path parameter. Network ID
    :param str rendezvous_point_id: rendezvousPointId path parameter. Rendezvous point ID
    """
    __args__ = dict()
    __args__['networkId'] = network_id
    __args__['rendezvousPointId'] = rendezvous_point_id
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('meraki:networks/getSwitchRoutingMulticastRendezvousPoints:getSwitchRoutingMulticastRendezvousPoints', __args__, opts=opts, typ=GetSwitchRoutingMulticastRendezvousPointsResult).value

    return AwaitableGetSwitchRoutingMulticastRendezvousPointsResult(
        id=pulumi.get(__ret__, 'id'),
        item=pulumi.get(__ret__, 'item'),
        items=pulumi.get(__ret__, 'items'),
        network_id=pulumi.get(__ret__, 'network_id'),
        rendezvous_point_id=pulumi.get(__ret__, 'rendezvous_point_id'))
def get_switch_routing_multicast_rendezvous_points_output(network_id: Optional[pulumi.Input[Optional[str]]] = None,
                                                          rendezvous_point_id: Optional[pulumi.Input[Optional[str]]] = None,
                                                          opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetSwitchRoutingMulticastRendezvousPointsResult]:
    """
    ## Example Usage


    :param str network_id: networkId path parameter. Network ID
    :param str rendezvous_point_id: rendezvousPointId path parameter. Rendezvous point ID
    """
    __args__ = dict()
    __args__['networkId'] = network_id
    __args__['rendezvousPointId'] = rendezvous_point_id
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('meraki:networks/getSwitchRoutingMulticastRendezvousPoints:getSwitchRoutingMulticastRendezvousPoints', __args__, opts=opts, typ=GetSwitchRoutingMulticastRendezvousPointsResult)
    return __ret__.apply(lambda __response__: GetSwitchRoutingMulticastRendezvousPointsResult(
        id=pulumi.get(__response__, 'id'),
        item=pulumi.get(__response__, 'item'),
        items=pulumi.get(__response__, 'items'),
        network_id=pulumi.get(__response__, 'network_id'),
        rendezvous_point_id=pulumi.get(__response__, 'rendezvous_point_id')))
