# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs

__all__ = [
    'GetVlanProfilesResult',
    'AwaitableGetVlanProfilesResult',
    'get_vlan_profiles',
    'get_vlan_profiles_output',
]

@pulumi.output_type
class GetVlanProfilesResult:
    """
    A collection of values returned by getVlanProfiles.
    """
    def __init__(__self__, id=None, iname=None, item=None, network_id=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if iname and not isinstance(iname, str):
            raise TypeError("Expected argument 'iname' to be a str")
        pulumi.set(__self__, "iname", iname)
        if item and not isinstance(item, dict):
            raise TypeError("Expected argument 'item' to be a dict")
        pulumi.set(__self__, "item", item)
        if network_id and not isinstance(network_id, str):
            raise TypeError("Expected argument 'network_id' to be a str")
        pulumi.set(__self__, "network_id", network_id)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def iname(self) -> str:
        """
        iname path parameter.
        """
        return pulumi.get(self, "iname")

    @property
    @pulumi.getter
    def item(self) -> 'outputs.GetVlanProfilesItemResult':
        return pulumi.get(self, "item")

    @property
    @pulumi.getter(name="networkId")
    def network_id(self) -> str:
        """
        networkId path parameter. Network ID
        """
        return pulumi.get(self, "network_id")


class AwaitableGetVlanProfilesResult(GetVlanProfilesResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetVlanProfilesResult(
            id=self.id,
            iname=self.iname,
            item=self.item,
            network_id=self.network_id)


def get_vlan_profiles(iname: Optional[str] = None,
                      network_id: Optional[str] = None,
                      opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetVlanProfilesResult:
    """
    ## Example Usage

    ```python
    import pulumi
    import pulumi_meraki as meraki

    example = meraki.networks.get_vlan_profiles(iname="string",
        network_id="string")
    pulumi.export("merakiNetworksVlanProfilesExample", example.item)
    ```


    :param str iname: iname path parameter.
    :param str network_id: networkId path parameter. Network ID
    """
    __args__ = dict()
    __args__['iname'] = iname
    __args__['networkId'] = network_id
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('meraki:networks/getVlanProfiles:getVlanProfiles', __args__, opts=opts, typ=GetVlanProfilesResult).value

    return AwaitableGetVlanProfilesResult(
        id=pulumi.get(__ret__, 'id'),
        iname=pulumi.get(__ret__, 'iname'),
        item=pulumi.get(__ret__, 'item'),
        network_id=pulumi.get(__ret__, 'network_id'))
def get_vlan_profiles_output(iname: Optional[pulumi.Input[str]] = None,
                             network_id: Optional[pulumi.Input[str]] = None,
                             opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetVlanProfilesResult]:
    """
    ## Example Usage

    ```python
    import pulumi
    import pulumi_meraki as meraki

    example = meraki.networks.get_vlan_profiles(iname="string",
        network_id="string")
    pulumi.export("merakiNetworksVlanProfilesExample", example.item)
    ```


    :param str iname: iname path parameter.
    :param str network_id: networkId path parameter. Network ID
    """
    __args__ = dict()
    __args__['iname'] = iname
    __args__['networkId'] = network_id
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('meraki:networks/getVlanProfiles:getVlanProfiles', __args__, opts=opts, typ=GetVlanProfilesResult)
    return __ret__.apply(lambda __response__: GetVlanProfilesResult(
        id=pulumi.get(__response__, 'id'),
        iname=pulumi.get(__response__, 'iname'),
        item=pulumi.get(__response__, 'item'),
        network_id=pulumi.get(__response__, 'network_id')))
