# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs

__all__ = [
    'GetWebhooksWebhookTestsResult',
    'AwaitableGetWebhooksWebhookTestsResult',
    'get_webhooks_webhook_tests',
    'get_webhooks_webhook_tests_output',
]

@pulumi.output_type
class GetWebhooksWebhookTestsResult:
    """
    A collection of values returned by getWebhooksWebhookTests.
    """
    def __init__(__self__, id=None, item=None, network_id=None, webhook_test_id=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if item and not isinstance(item, dict):
            raise TypeError("Expected argument 'item' to be a dict")
        pulumi.set(__self__, "item", item)
        if network_id and not isinstance(network_id, str):
            raise TypeError("Expected argument 'network_id' to be a str")
        pulumi.set(__self__, "network_id", network_id)
        if webhook_test_id and not isinstance(webhook_test_id, str):
            raise TypeError("Expected argument 'webhook_test_id' to be a str")
        pulumi.set(__self__, "webhook_test_id", webhook_test_id)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def item(self) -> 'outputs.GetWebhooksWebhookTestsItemResult':
        return pulumi.get(self, "item")

    @property
    @pulumi.getter(name="networkId")
    def network_id(self) -> str:
        """
        networkId path parameter. Network ID
        """
        return pulumi.get(self, "network_id")

    @property
    @pulumi.getter(name="webhookTestId")
    def webhook_test_id(self) -> str:
        """
        webhookTestId path parameter. Webhook test ID
        """
        return pulumi.get(self, "webhook_test_id")


class AwaitableGetWebhooksWebhookTestsResult(GetWebhooksWebhookTestsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetWebhooksWebhookTestsResult(
            id=self.id,
            item=self.item,
            network_id=self.network_id,
            webhook_test_id=self.webhook_test_id)


def get_webhooks_webhook_tests(network_id: Optional[str] = None,
                               webhook_test_id: Optional[str] = None,
                               opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetWebhooksWebhookTestsResult:
    """
    ## Example Usage

    ```python
    import pulumi
    import pulumi_meraki as meraki

    example = meraki.networks.get_webhooks_webhook_tests(network_id="string",
        webhook_test_id="string")
    pulumi.export("merakiNetworksWebhooksWebhookTestsExample", example.item)
    ```


    :param str network_id: networkId path parameter. Network ID
    :param str webhook_test_id: webhookTestId path parameter. Webhook test ID
    """
    __args__ = dict()
    __args__['networkId'] = network_id
    __args__['webhookTestId'] = webhook_test_id
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('meraki:networks/getWebhooksWebhookTests:getWebhooksWebhookTests', __args__, opts=opts, typ=GetWebhooksWebhookTestsResult).value

    return AwaitableGetWebhooksWebhookTestsResult(
        id=pulumi.get(__ret__, 'id'),
        item=pulumi.get(__ret__, 'item'),
        network_id=pulumi.get(__ret__, 'network_id'),
        webhook_test_id=pulumi.get(__ret__, 'webhook_test_id'))
def get_webhooks_webhook_tests_output(network_id: Optional[pulumi.Input[str]] = None,
                                      webhook_test_id: Optional[pulumi.Input[str]] = None,
                                      opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetWebhooksWebhookTestsResult]:
    """
    ## Example Usage

    ```python
    import pulumi
    import pulumi_meraki as meraki

    example = meraki.networks.get_webhooks_webhook_tests(network_id="string",
        webhook_test_id="string")
    pulumi.export("merakiNetworksWebhooksWebhookTestsExample", example.item)
    ```


    :param str network_id: networkId path parameter. Network ID
    :param str webhook_test_id: webhookTestId path parameter. Webhook test ID
    """
    __args__ = dict()
    __args__['networkId'] = network_id
    __args__['webhookTestId'] = webhook_test_id
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('meraki:networks/getWebhooksWebhookTests:getWebhooksWebhookTests', __args__, opts=opts, typ=GetWebhooksWebhookTestsResult)
    return __ret__.apply(lambda __response__: GetWebhooksWebhookTestsResult(
        id=pulumi.get(__response__, 'id'),
        item=pulumi.get(__response__, 'item'),
        network_id=pulumi.get(__response__, 'network_id'),
        webhook_test_id=pulumi.get(__response__, 'webhook_test_id')))
