# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs
from ._inputs import *

__all__ = ['WirelessSsidsFirewallL3FirewallRulesArgs', 'WirelessSsidsFirewallL3FirewallRules']

@pulumi.input_type
class WirelessSsidsFirewallL3FirewallRulesArgs:
    def __init__(__self__, *,
                 network_id: pulumi.Input[str],
                 number: pulumi.Input[str],
                 allow_lan_access: Optional[pulumi.Input[bool]] = None,
                 rules: Optional[pulumi.Input[Sequence[pulumi.Input['WirelessSsidsFirewallL3FirewallRulesRuleArgs']]]] = None,
                 rules_responses: Optional[pulumi.Input[Sequence[pulumi.Input['WirelessSsidsFirewallL3FirewallRulesRulesResponseArgs']]]] = None):
        """
        The set of arguments for constructing a WirelessSsidsFirewallL3FirewallRules resource.
        :param pulumi.Input[str] network_id: networkId path parameter. Network ID
        :param pulumi.Input[str] number: number path parameter.
        :param pulumi.Input[bool] allow_lan_access: Allow wireless client access to local LAN (boolean value - true allows access and false denies access) (optional)
        :param pulumi.Input[Sequence[pulumi.Input['WirelessSsidsFirewallL3FirewallRulesRuleArgs']]] rules: An ordered array of the firewall rules for this SSID (not including the local LAN access rule or the default rule).
        :param pulumi.Input[Sequence[pulumi.Input['WirelessSsidsFirewallL3FirewallRulesRulesResponseArgs']]] rules_responses: An ordered array of the firewall rules for this SSID (not including the local LAN access rule or the default rule).
        """
        pulumi.set(__self__, "network_id", network_id)
        pulumi.set(__self__, "number", number)
        if allow_lan_access is not None:
            pulumi.set(__self__, "allow_lan_access", allow_lan_access)
        if rules is not None:
            pulumi.set(__self__, "rules", rules)
        if rules_responses is not None:
            pulumi.set(__self__, "rules_responses", rules_responses)

    @property
    @pulumi.getter(name="networkId")
    def network_id(self) -> pulumi.Input[str]:
        """
        networkId path parameter. Network ID
        """
        return pulumi.get(self, "network_id")

    @network_id.setter
    def network_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "network_id", value)

    @property
    @pulumi.getter
    def number(self) -> pulumi.Input[str]:
        """
        number path parameter.
        """
        return pulumi.get(self, "number")

    @number.setter
    def number(self, value: pulumi.Input[str]):
        pulumi.set(self, "number", value)

    @property
    @pulumi.getter(name="allowLanAccess")
    def allow_lan_access(self) -> Optional[pulumi.Input[bool]]:
        """
        Allow wireless client access to local LAN (boolean value - true allows access and false denies access) (optional)
        """
        return pulumi.get(self, "allow_lan_access")

    @allow_lan_access.setter
    def allow_lan_access(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "allow_lan_access", value)

    @property
    @pulumi.getter
    def rules(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['WirelessSsidsFirewallL3FirewallRulesRuleArgs']]]]:
        """
        An ordered array of the firewall rules for this SSID (not including the local LAN access rule or the default rule).
        """
        return pulumi.get(self, "rules")

    @rules.setter
    def rules(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['WirelessSsidsFirewallL3FirewallRulesRuleArgs']]]]):
        pulumi.set(self, "rules", value)

    @property
    @pulumi.getter(name="rulesResponses")
    def rules_responses(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['WirelessSsidsFirewallL3FirewallRulesRulesResponseArgs']]]]:
        """
        An ordered array of the firewall rules for this SSID (not including the local LAN access rule or the default rule).
        """
        return pulumi.get(self, "rules_responses")

    @rules_responses.setter
    def rules_responses(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['WirelessSsidsFirewallL3FirewallRulesRulesResponseArgs']]]]):
        pulumi.set(self, "rules_responses", value)


@pulumi.input_type
class _WirelessSsidsFirewallL3FirewallRulesState:
    def __init__(__self__, *,
                 allow_lan_access: Optional[pulumi.Input[bool]] = None,
                 network_id: Optional[pulumi.Input[str]] = None,
                 number: Optional[pulumi.Input[str]] = None,
                 rules: Optional[pulumi.Input[Sequence[pulumi.Input['WirelessSsidsFirewallL3FirewallRulesRuleArgs']]]] = None,
                 rules_responses: Optional[pulumi.Input[Sequence[pulumi.Input['WirelessSsidsFirewallL3FirewallRulesRulesResponseArgs']]]] = None):
        """
        Input properties used for looking up and filtering WirelessSsidsFirewallL3FirewallRules resources.
        :param pulumi.Input[bool] allow_lan_access: Allow wireless client access to local LAN (boolean value - true allows access and false denies access) (optional)
        :param pulumi.Input[str] network_id: networkId path parameter. Network ID
        :param pulumi.Input[str] number: number path parameter.
        :param pulumi.Input[Sequence[pulumi.Input['WirelessSsidsFirewallL3FirewallRulesRuleArgs']]] rules: An ordered array of the firewall rules for this SSID (not including the local LAN access rule or the default rule).
        :param pulumi.Input[Sequence[pulumi.Input['WirelessSsidsFirewallL3FirewallRulesRulesResponseArgs']]] rules_responses: An ordered array of the firewall rules for this SSID (not including the local LAN access rule or the default rule).
        """
        if allow_lan_access is not None:
            pulumi.set(__self__, "allow_lan_access", allow_lan_access)
        if network_id is not None:
            pulumi.set(__self__, "network_id", network_id)
        if number is not None:
            pulumi.set(__self__, "number", number)
        if rules is not None:
            pulumi.set(__self__, "rules", rules)
        if rules_responses is not None:
            pulumi.set(__self__, "rules_responses", rules_responses)

    @property
    @pulumi.getter(name="allowLanAccess")
    def allow_lan_access(self) -> Optional[pulumi.Input[bool]]:
        """
        Allow wireless client access to local LAN (boolean value - true allows access and false denies access) (optional)
        """
        return pulumi.get(self, "allow_lan_access")

    @allow_lan_access.setter
    def allow_lan_access(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "allow_lan_access", value)

    @property
    @pulumi.getter(name="networkId")
    def network_id(self) -> Optional[pulumi.Input[str]]:
        """
        networkId path parameter. Network ID
        """
        return pulumi.get(self, "network_id")

    @network_id.setter
    def network_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "network_id", value)

    @property
    @pulumi.getter
    def number(self) -> Optional[pulumi.Input[str]]:
        """
        number path parameter.
        """
        return pulumi.get(self, "number")

    @number.setter
    def number(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "number", value)

    @property
    @pulumi.getter
    def rules(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['WirelessSsidsFirewallL3FirewallRulesRuleArgs']]]]:
        """
        An ordered array of the firewall rules for this SSID (not including the local LAN access rule or the default rule).
        """
        return pulumi.get(self, "rules")

    @rules.setter
    def rules(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['WirelessSsidsFirewallL3FirewallRulesRuleArgs']]]]):
        pulumi.set(self, "rules", value)

    @property
    @pulumi.getter(name="rulesResponses")
    def rules_responses(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['WirelessSsidsFirewallL3FirewallRulesRulesResponseArgs']]]]:
        """
        An ordered array of the firewall rules for this SSID (not including the local LAN access rule or the default rule).
        """
        return pulumi.get(self, "rules_responses")

    @rules_responses.setter
    def rules_responses(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['WirelessSsidsFirewallL3FirewallRulesRulesResponseArgs']]]]):
        pulumi.set(self, "rules_responses", value)


class WirelessSsidsFirewallL3FirewallRules(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 allow_lan_access: Optional[pulumi.Input[bool]] = None,
                 network_id: Optional[pulumi.Input[str]] = None,
                 number: Optional[pulumi.Input[str]] = None,
                 rules: Optional[pulumi.Input[Sequence[pulumi.Input[Union['WirelessSsidsFirewallL3FirewallRulesRuleArgs', 'WirelessSsidsFirewallL3FirewallRulesRuleArgsDict']]]]] = None,
                 rules_responses: Optional[pulumi.Input[Sequence[pulumi.Input[Union['WirelessSsidsFirewallL3FirewallRulesRulesResponseArgs', 'WirelessSsidsFirewallL3FirewallRulesRulesResponseArgsDict']]]]] = None,
                 __props__=None):
        """
        ## Example Usage

        ## Import

        ```sh
        $ pulumi import meraki:networks/wirelessSsidsFirewallL3FirewallRules:WirelessSsidsFirewallL3FirewallRules example "network_id,number"
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[bool] allow_lan_access: Allow wireless client access to local LAN (boolean value - true allows access and false denies access) (optional)
        :param pulumi.Input[str] network_id: networkId path parameter. Network ID
        :param pulumi.Input[str] number: number path parameter.
        :param pulumi.Input[Sequence[pulumi.Input[Union['WirelessSsidsFirewallL3FirewallRulesRuleArgs', 'WirelessSsidsFirewallL3FirewallRulesRuleArgsDict']]]] rules: An ordered array of the firewall rules for this SSID (not including the local LAN access rule or the default rule).
        :param pulumi.Input[Sequence[pulumi.Input[Union['WirelessSsidsFirewallL3FirewallRulesRulesResponseArgs', 'WirelessSsidsFirewallL3FirewallRulesRulesResponseArgsDict']]]] rules_responses: An ordered array of the firewall rules for this SSID (not including the local LAN access rule or the default rule).
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: WirelessSsidsFirewallL3FirewallRulesArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        ## Example Usage

        ## Import

        ```sh
        $ pulumi import meraki:networks/wirelessSsidsFirewallL3FirewallRules:WirelessSsidsFirewallL3FirewallRules example "network_id,number"
        ```

        :param str resource_name: The name of the resource.
        :param WirelessSsidsFirewallL3FirewallRulesArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(WirelessSsidsFirewallL3FirewallRulesArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 allow_lan_access: Optional[pulumi.Input[bool]] = None,
                 network_id: Optional[pulumi.Input[str]] = None,
                 number: Optional[pulumi.Input[str]] = None,
                 rules: Optional[pulumi.Input[Sequence[pulumi.Input[Union['WirelessSsidsFirewallL3FirewallRulesRuleArgs', 'WirelessSsidsFirewallL3FirewallRulesRuleArgsDict']]]]] = None,
                 rules_responses: Optional[pulumi.Input[Sequence[pulumi.Input[Union['WirelessSsidsFirewallL3FirewallRulesRulesResponseArgs', 'WirelessSsidsFirewallL3FirewallRulesRulesResponseArgsDict']]]]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = WirelessSsidsFirewallL3FirewallRulesArgs.__new__(WirelessSsidsFirewallL3FirewallRulesArgs)

            __props__.__dict__["allow_lan_access"] = allow_lan_access
            if network_id is None and not opts.urn:
                raise TypeError("Missing required property 'network_id'")
            __props__.__dict__["network_id"] = network_id
            if number is None and not opts.urn:
                raise TypeError("Missing required property 'number'")
            __props__.__dict__["number"] = number
            __props__.__dict__["rules"] = rules
            __props__.__dict__["rules_responses"] = rules_responses
        super(WirelessSsidsFirewallL3FirewallRules, __self__).__init__(
            'meraki:networks/wirelessSsidsFirewallL3FirewallRules:WirelessSsidsFirewallL3FirewallRules',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            allow_lan_access: Optional[pulumi.Input[bool]] = None,
            network_id: Optional[pulumi.Input[str]] = None,
            number: Optional[pulumi.Input[str]] = None,
            rules: Optional[pulumi.Input[Sequence[pulumi.Input[Union['WirelessSsidsFirewallL3FirewallRulesRuleArgs', 'WirelessSsidsFirewallL3FirewallRulesRuleArgsDict']]]]] = None,
            rules_responses: Optional[pulumi.Input[Sequence[pulumi.Input[Union['WirelessSsidsFirewallL3FirewallRulesRulesResponseArgs', 'WirelessSsidsFirewallL3FirewallRulesRulesResponseArgsDict']]]]] = None) -> 'WirelessSsidsFirewallL3FirewallRules':
        """
        Get an existing WirelessSsidsFirewallL3FirewallRules resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[bool] allow_lan_access: Allow wireless client access to local LAN (boolean value - true allows access and false denies access) (optional)
        :param pulumi.Input[str] network_id: networkId path parameter. Network ID
        :param pulumi.Input[str] number: number path parameter.
        :param pulumi.Input[Sequence[pulumi.Input[Union['WirelessSsidsFirewallL3FirewallRulesRuleArgs', 'WirelessSsidsFirewallL3FirewallRulesRuleArgsDict']]]] rules: An ordered array of the firewall rules for this SSID (not including the local LAN access rule or the default rule).
        :param pulumi.Input[Sequence[pulumi.Input[Union['WirelessSsidsFirewallL3FirewallRulesRulesResponseArgs', 'WirelessSsidsFirewallL3FirewallRulesRulesResponseArgsDict']]]] rules_responses: An ordered array of the firewall rules for this SSID (not including the local LAN access rule or the default rule).
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _WirelessSsidsFirewallL3FirewallRulesState.__new__(_WirelessSsidsFirewallL3FirewallRulesState)

        __props__.__dict__["allow_lan_access"] = allow_lan_access
        __props__.__dict__["network_id"] = network_id
        __props__.__dict__["number"] = number
        __props__.__dict__["rules"] = rules
        __props__.__dict__["rules_responses"] = rules_responses
        return WirelessSsidsFirewallL3FirewallRules(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="allowLanAccess")
    def allow_lan_access(self) -> pulumi.Output[Optional[bool]]:
        """
        Allow wireless client access to local LAN (boolean value - true allows access and false denies access) (optional)
        """
        return pulumi.get(self, "allow_lan_access")

    @property
    @pulumi.getter(name="networkId")
    def network_id(self) -> pulumi.Output[str]:
        """
        networkId path parameter. Network ID
        """
        return pulumi.get(self, "network_id")

    @property
    @pulumi.getter
    def number(self) -> pulumi.Output[str]:
        """
        number path parameter.
        """
        return pulumi.get(self, "number")

    @property
    @pulumi.getter
    def rules(self) -> pulumi.Output[Sequence['outputs.WirelessSsidsFirewallL3FirewallRulesRule']]:
        """
        An ordered array of the firewall rules for this SSID (not including the local LAN access rule or the default rule).
        """
        return pulumi.get(self, "rules")

    @property
    @pulumi.getter(name="rulesResponses")
    def rules_responses(self) -> pulumi.Output[Sequence['outputs.WirelessSsidsFirewallL3FirewallRulesRulesResponse']]:
        """
        An ordered array of the firewall rules for this SSID (not including the local LAN access rule or the default rule).
        """
        return pulumi.get(self, "rules_responses")

