# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs
from ._inputs import *

__all__ = ['WirelessSsidsFirewallL7FirewallRulesArgs', 'WirelessSsidsFirewallL7FirewallRules']

@pulumi.input_type
class WirelessSsidsFirewallL7FirewallRulesArgs:
    def __init__(__self__, *,
                 network_id: pulumi.Input[str],
                 number: pulumi.Input[str],
                 rules: Optional[pulumi.Input[Sequence[pulumi.Input['WirelessSsidsFirewallL7FirewallRulesRuleArgs']]]] = None):
        """
        The set of arguments for constructing a WirelessSsidsFirewallL7FirewallRules resource.
        :param pulumi.Input[str] network_id: networkId path parameter. Network ID
        :param pulumi.Input[str] number: number path parameter.
        :param pulumi.Input[Sequence[pulumi.Input['WirelessSsidsFirewallL7FirewallRulesRuleArgs']]] rules: An ordered array of the firewall rules for this SSID (not including the local LAN access rule or the default rule).
        """
        pulumi.set(__self__, "network_id", network_id)
        pulumi.set(__self__, "number", number)
        if rules is not None:
            pulumi.set(__self__, "rules", rules)

    @property
    @pulumi.getter(name="networkId")
    def network_id(self) -> pulumi.Input[str]:
        """
        networkId path parameter. Network ID
        """
        return pulumi.get(self, "network_id")

    @network_id.setter
    def network_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "network_id", value)

    @property
    @pulumi.getter
    def number(self) -> pulumi.Input[str]:
        """
        number path parameter.
        """
        return pulumi.get(self, "number")

    @number.setter
    def number(self, value: pulumi.Input[str]):
        pulumi.set(self, "number", value)

    @property
    @pulumi.getter
    def rules(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['WirelessSsidsFirewallL7FirewallRulesRuleArgs']]]]:
        """
        An ordered array of the firewall rules for this SSID (not including the local LAN access rule or the default rule).
        """
        return pulumi.get(self, "rules")

    @rules.setter
    def rules(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['WirelessSsidsFirewallL7FirewallRulesRuleArgs']]]]):
        pulumi.set(self, "rules", value)


@pulumi.input_type
class _WirelessSsidsFirewallL7FirewallRulesState:
    def __init__(__self__, *,
                 network_id: Optional[pulumi.Input[str]] = None,
                 number: Optional[pulumi.Input[str]] = None,
                 rules: Optional[pulumi.Input[Sequence[pulumi.Input['WirelessSsidsFirewallL7FirewallRulesRuleArgs']]]] = None):
        """
        Input properties used for looking up and filtering WirelessSsidsFirewallL7FirewallRules resources.
        :param pulumi.Input[str] network_id: networkId path parameter. Network ID
        :param pulumi.Input[str] number: number path parameter.
        :param pulumi.Input[Sequence[pulumi.Input['WirelessSsidsFirewallL7FirewallRulesRuleArgs']]] rules: An ordered array of the firewall rules for this SSID (not including the local LAN access rule or the default rule).
        """
        if network_id is not None:
            pulumi.set(__self__, "network_id", network_id)
        if number is not None:
            pulumi.set(__self__, "number", number)
        if rules is not None:
            pulumi.set(__self__, "rules", rules)

    @property
    @pulumi.getter(name="networkId")
    def network_id(self) -> Optional[pulumi.Input[str]]:
        """
        networkId path parameter. Network ID
        """
        return pulumi.get(self, "network_id")

    @network_id.setter
    def network_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "network_id", value)

    @property
    @pulumi.getter
    def number(self) -> Optional[pulumi.Input[str]]:
        """
        number path parameter.
        """
        return pulumi.get(self, "number")

    @number.setter
    def number(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "number", value)

    @property
    @pulumi.getter
    def rules(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['WirelessSsidsFirewallL7FirewallRulesRuleArgs']]]]:
        """
        An ordered array of the firewall rules for this SSID (not including the local LAN access rule or the default rule).
        """
        return pulumi.get(self, "rules")

    @rules.setter
    def rules(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['WirelessSsidsFirewallL7FirewallRulesRuleArgs']]]]):
        pulumi.set(self, "rules", value)


class WirelessSsidsFirewallL7FirewallRules(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 network_id: Optional[pulumi.Input[str]] = None,
                 number: Optional[pulumi.Input[str]] = None,
                 rules: Optional[pulumi.Input[Sequence[pulumi.Input[Union['WirelessSsidsFirewallL7FirewallRulesRuleArgs', 'WirelessSsidsFirewallL7FirewallRulesRuleArgsDict']]]]] = None,
                 __props__=None):
        """
        ## Example Usage

        ```python
        import pulumi
        import pulumi_meraki as meraki

        example = meraki.networks.WirelessSsidsFirewallL7FirewallRules("example",
            network_id="string",
            number="string",
            rules=[{
                "policy": "deny",
                "type": "host",
                "value": "google.com",
            }])
        pulumi.export("merakiNetworksWirelessSsidsFirewallL7FirewallRulesExample", example)
        ```

        ## Import

        ```sh
        $ pulumi import meraki:networks/wirelessSsidsFirewallL7FirewallRules:WirelessSsidsFirewallL7FirewallRules example "network_id,number"
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] network_id: networkId path parameter. Network ID
        :param pulumi.Input[str] number: number path parameter.
        :param pulumi.Input[Sequence[pulumi.Input[Union['WirelessSsidsFirewallL7FirewallRulesRuleArgs', 'WirelessSsidsFirewallL7FirewallRulesRuleArgsDict']]]] rules: An ordered array of the firewall rules for this SSID (not including the local LAN access rule or the default rule).
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: WirelessSsidsFirewallL7FirewallRulesArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        ## Example Usage

        ```python
        import pulumi
        import pulumi_meraki as meraki

        example = meraki.networks.WirelessSsidsFirewallL7FirewallRules("example",
            network_id="string",
            number="string",
            rules=[{
                "policy": "deny",
                "type": "host",
                "value": "google.com",
            }])
        pulumi.export("merakiNetworksWirelessSsidsFirewallL7FirewallRulesExample", example)
        ```

        ## Import

        ```sh
        $ pulumi import meraki:networks/wirelessSsidsFirewallL7FirewallRules:WirelessSsidsFirewallL7FirewallRules example "network_id,number"
        ```

        :param str resource_name: The name of the resource.
        :param WirelessSsidsFirewallL7FirewallRulesArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(WirelessSsidsFirewallL7FirewallRulesArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 network_id: Optional[pulumi.Input[str]] = None,
                 number: Optional[pulumi.Input[str]] = None,
                 rules: Optional[pulumi.Input[Sequence[pulumi.Input[Union['WirelessSsidsFirewallL7FirewallRulesRuleArgs', 'WirelessSsidsFirewallL7FirewallRulesRuleArgsDict']]]]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = WirelessSsidsFirewallL7FirewallRulesArgs.__new__(WirelessSsidsFirewallL7FirewallRulesArgs)

            if network_id is None and not opts.urn:
                raise TypeError("Missing required property 'network_id'")
            __props__.__dict__["network_id"] = network_id
            if number is None and not opts.urn:
                raise TypeError("Missing required property 'number'")
            __props__.__dict__["number"] = number
            __props__.__dict__["rules"] = rules
        super(WirelessSsidsFirewallL7FirewallRules, __self__).__init__(
            'meraki:networks/wirelessSsidsFirewallL7FirewallRules:WirelessSsidsFirewallL7FirewallRules',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            network_id: Optional[pulumi.Input[str]] = None,
            number: Optional[pulumi.Input[str]] = None,
            rules: Optional[pulumi.Input[Sequence[pulumi.Input[Union['WirelessSsidsFirewallL7FirewallRulesRuleArgs', 'WirelessSsidsFirewallL7FirewallRulesRuleArgsDict']]]]] = None) -> 'WirelessSsidsFirewallL7FirewallRules':
        """
        Get an existing WirelessSsidsFirewallL7FirewallRules resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] network_id: networkId path parameter. Network ID
        :param pulumi.Input[str] number: number path parameter.
        :param pulumi.Input[Sequence[pulumi.Input[Union['WirelessSsidsFirewallL7FirewallRulesRuleArgs', 'WirelessSsidsFirewallL7FirewallRulesRuleArgsDict']]]] rules: An ordered array of the firewall rules for this SSID (not including the local LAN access rule or the default rule).
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _WirelessSsidsFirewallL7FirewallRulesState.__new__(_WirelessSsidsFirewallL7FirewallRulesState)

        __props__.__dict__["network_id"] = network_id
        __props__.__dict__["number"] = number
        __props__.__dict__["rules"] = rules
        return WirelessSsidsFirewallL7FirewallRules(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="networkId")
    def network_id(self) -> pulumi.Output[str]:
        """
        networkId path parameter. Network ID
        """
        return pulumi.get(self, "network_id")

    @property
    @pulumi.getter
    def number(self) -> pulumi.Output[str]:
        """
        number path parameter.
        """
        return pulumi.get(self, "number")

    @property
    @pulumi.getter
    def rules(self) -> pulumi.Output[Sequence['outputs.WirelessSsidsFirewallL7FirewallRulesRule']]:
        """
        An ordered array of the firewall rules for this SSID (not including the local LAN access rule or the default rule).
        """
        return pulumi.get(self, "rules")

