# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs

__all__ = [
    'GetAdaptivePolicyAclsResult',
    'AwaitableGetAdaptivePolicyAclsResult',
    'get_adaptive_policy_acls',
    'get_adaptive_policy_acls_output',
]

@pulumi.output_type
class GetAdaptivePolicyAclsResult:
    """
    A collection of values returned by getAdaptivePolicyAcls.
    """
    def __init__(__self__, acl_id=None, id=None, item=None, items=None, organization_id=None):
        if acl_id and not isinstance(acl_id, str):
            raise TypeError("Expected argument 'acl_id' to be a str")
        pulumi.set(__self__, "acl_id", acl_id)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if item and not isinstance(item, dict):
            raise TypeError("Expected argument 'item' to be a dict")
        pulumi.set(__self__, "item", item)
        if items and not isinstance(items, list):
            raise TypeError("Expected argument 'items' to be a list")
        pulumi.set(__self__, "items", items)
        if organization_id and not isinstance(organization_id, str):
            raise TypeError("Expected argument 'organization_id' to be a str")
        pulumi.set(__self__, "organization_id", organization_id)

    @property
    @pulumi.getter(name="aclId")
    def acl_id(self) -> Optional[str]:
        """
        aclId path parameter. Acl ID
        """
        return pulumi.get(self, "acl_id")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def item(self) -> 'outputs.GetAdaptivePolicyAclsItemResult':
        return pulumi.get(self, "item")

    @property
    @pulumi.getter
    def items(self) -> Sequence['outputs.GetAdaptivePolicyAclsItemResult']:
        """
        Array of ResponseOrganizationsGetOrganizationAdaptivePolicyAcls
        """
        return pulumi.get(self, "items")

    @property
    @pulumi.getter(name="organizationId")
    def organization_id(self) -> Optional[str]:
        """
        organizationId path parameter. Organization ID
        """
        return pulumi.get(self, "organization_id")


class AwaitableGetAdaptivePolicyAclsResult(GetAdaptivePolicyAclsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetAdaptivePolicyAclsResult(
            acl_id=self.acl_id,
            id=self.id,
            item=self.item,
            items=self.items,
            organization_id=self.organization_id)


def get_adaptive_policy_acls(acl_id: Optional[str] = None,
                             organization_id: Optional[str] = None,
                             opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetAdaptivePolicyAclsResult:
    """
    ## Example Usage


    :param str acl_id: aclId path parameter. Acl ID
    :param str organization_id: organizationId path parameter. Organization ID
    """
    __args__ = dict()
    __args__['aclId'] = acl_id
    __args__['organizationId'] = organization_id
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('meraki:organizations/getAdaptivePolicyAcls:getAdaptivePolicyAcls', __args__, opts=opts, typ=GetAdaptivePolicyAclsResult).value

    return AwaitableGetAdaptivePolicyAclsResult(
        acl_id=pulumi.get(__ret__, 'acl_id'),
        id=pulumi.get(__ret__, 'id'),
        item=pulumi.get(__ret__, 'item'),
        items=pulumi.get(__ret__, 'items'),
        organization_id=pulumi.get(__ret__, 'organization_id'))
def get_adaptive_policy_acls_output(acl_id: Optional[pulumi.Input[Optional[str]]] = None,
                                    organization_id: Optional[pulumi.Input[Optional[str]]] = None,
                                    opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetAdaptivePolicyAclsResult]:
    """
    ## Example Usage


    :param str acl_id: aclId path parameter. Acl ID
    :param str organization_id: organizationId path parameter. Organization ID
    """
    __args__ = dict()
    __args__['aclId'] = acl_id
    __args__['organizationId'] = organization_id
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('meraki:organizations/getAdaptivePolicyAcls:getAdaptivePolicyAcls', __args__, opts=opts, typ=GetAdaptivePolicyAclsResult)
    return __ret__.apply(lambda __response__: GetAdaptivePolicyAclsResult(
        acl_id=pulumi.get(__response__, 'acl_id'),
        id=pulumi.get(__response__, 'id'),
        item=pulumi.get(__response__, 'item'),
        items=pulumi.get(__response__, 'items'),
        organization_id=pulumi.get(__response__, 'organization_id')))
