# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs

__all__ = [
    'GetInventoryOnboardingCloudMonitoringNetworksResult',
    'AwaitableGetInventoryOnboardingCloudMonitoringNetworksResult',
    'get_inventory_onboarding_cloud_monitoring_networks',
    'get_inventory_onboarding_cloud_monitoring_networks_output',
]

@pulumi.output_type
class GetInventoryOnboardingCloudMonitoringNetworksResult:
    """
    A collection of values returned by getInventoryOnboardingCloudMonitoringNetworks.
    """
    def __init__(__self__, device_type=None, ending_before=None, id=None, items=None, organization_id=None, per_page=None, search=None, starting_after=None):
        if device_type and not isinstance(device_type, str):
            raise TypeError("Expected argument 'device_type' to be a str")
        pulumi.set(__self__, "device_type", device_type)
        if ending_before and not isinstance(ending_before, str):
            raise TypeError("Expected argument 'ending_before' to be a str")
        pulumi.set(__self__, "ending_before", ending_before)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if items and not isinstance(items, list):
            raise TypeError("Expected argument 'items' to be a list")
        pulumi.set(__self__, "items", items)
        if organization_id and not isinstance(organization_id, str):
            raise TypeError("Expected argument 'organization_id' to be a str")
        pulumi.set(__self__, "organization_id", organization_id)
        if per_page and not isinstance(per_page, int):
            raise TypeError("Expected argument 'per_page' to be a int")
        pulumi.set(__self__, "per_page", per_page)
        if search and not isinstance(search, str):
            raise TypeError("Expected argument 'search' to be a str")
        pulumi.set(__self__, "search", search)
        if starting_after and not isinstance(starting_after, str):
            raise TypeError("Expected argument 'starting_after' to be a str")
        pulumi.set(__self__, "starting_after", starting_after)

    @property
    @pulumi.getter(name="deviceType")
    def device_type(self) -> str:
        """
        deviceType query parameter. Device Type switch or wireless controller
        """
        return pulumi.get(self, "device_type")

    @property
    @pulumi.getter(name="endingBefore")
    def ending_before(self) -> Optional[str]:
        """
        endingBefore query parameter. A token used by the server to indicate the end of the page. Often this is a timestamp or an ID but it is not limited to those. This parameter should not be defined by client applications. The link for the first, last, prev, or next page in the HTTP Link header should define it.
        """
        return pulumi.get(self, "ending_before")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def items(self) -> Sequence['outputs.GetInventoryOnboardingCloudMonitoringNetworksItemResult']:
        """
        Array of ResponseOrganizationsGetOrganizationInventoryOnboardingCloudMonitoringNetworks
        """
        return pulumi.get(self, "items")

    @property
    @pulumi.getter(name="organizationId")
    def organization_id(self) -> str:
        """
        organizationId path parameter. Organization ID
        """
        return pulumi.get(self, "organization_id")

    @property
    @pulumi.getter(name="perPage")
    def per_page(self) -> Optional[int]:
        """
        perPage query parameter. The number of entries per page returned. Acceptable range is 3 100000. Default is 1000.
        """
        return pulumi.get(self, "per_page")

    @property
    @pulumi.getter
    def search(self) -> Optional[str]:
        """
        search query parameter. Optional parameter to search on network name
        """
        return pulumi.get(self, "search")

    @property
    @pulumi.getter(name="startingAfter")
    def starting_after(self) -> Optional[str]:
        """
        startingAfter query parameter. A token used by the server to indicate the start of the page. Often this is a timestamp or an ID but it is not limited to those. This parameter should not be defined by client applications. The link for the first, last, prev, or next page in the HTTP Link header should define it.
        """
        return pulumi.get(self, "starting_after")


class AwaitableGetInventoryOnboardingCloudMonitoringNetworksResult(GetInventoryOnboardingCloudMonitoringNetworksResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetInventoryOnboardingCloudMonitoringNetworksResult(
            device_type=self.device_type,
            ending_before=self.ending_before,
            id=self.id,
            items=self.items,
            organization_id=self.organization_id,
            per_page=self.per_page,
            search=self.search,
            starting_after=self.starting_after)


def get_inventory_onboarding_cloud_monitoring_networks(device_type: Optional[str] = None,
                                                       ending_before: Optional[str] = None,
                                                       organization_id: Optional[str] = None,
                                                       per_page: Optional[int] = None,
                                                       search: Optional[str] = None,
                                                       starting_after: Optional[str] = None,
                                                       opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetInventoryOnboardingCloudMonitoringNetworksResult:
    """
    ## Example Usage

    ```python
    import pulumi
    import pulumi_meraki as meraki

    example = meraki.organizations.get_inventory_onboarding_cloud_monitoring_networks(device_type="string",
        ending_before="string",
        organization_id="string",
        per_page=1,
        search="string",
        starting_after="string")
    pulumi.export("merakiOrganizationsInventoryOnboardingCloudMonitoringNetworksExample", example.items)
    ```


    :param str device_type: deviceType query parameter. Device Type switch or wireless controller
    :param str ending_before: endingBefore query parameter. A token used by the server to indicate the end of the page. Often this is a timestamp or an ID but it is not limited to those. This parameter should not be defined by client applications. The link for the first, last, prev, or next page in the HTTP Link header should define it.
    :param str organization_id: organizationId path parameter. Organization ID
    :param int per_page: perPage query parameter. The number of entries per page returned. Acceptable range is 3 100000. Default is 1000.
    :param str search: search query parameter. Optional parameter to search on network name
    :param str starting_after: startingAfter query parameter. A token used by the server to indicate the start of the page. Often this is a timestamp or an ID but it is not limited to those. This parameter should not be defined by client applications. The link for the first, last, prev, or next page in the HTTP Link header should define it.
    """
    __args__ = dict()
    __args__['deviceType'] = device_type
    __args__['endingBefore'] = ending_before
    __args__['organizationId'] = organization_id
    __args__['perPage'] = per_page
    __args__['search'] = search
    __args__['startingAfter'] = starting_after
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('meraki:organizations/getInventoryOnboardingCloudMonitoringNetworks:getInventoryOnboardingCloudMonitoringNetworks', __args__, opts=opts, typ=GetInventoryOnboardingCloudMonitoringNetworksResult).value

    return AwaitableGetInventoryOnboardingCloudMonitoringNetworksResult(
        device_type=pulumi.get(__ret__, 'device_type'),
        ending_before=pulumi.get(__ret__, 'ending_before'),
        id=pulumi.get(__ret__, 'id'),
        items=pulumi.get(__ret__, 'items'),
        organization_id=pulumi.get(__ret__, 'organization_id'),
        per_page=pulumi.get(__ret__, 'per_page'),
        search=pulumi.get(__ret__, 'search'),
        starting_after=pulumi.get(__ret__, 'starting_after'))
def get_inventory_onboarding_cloud_monitoring_networks_output(device_type: Optional[pulumi.Input[str]] = None,
                                                              ending_before: Optional[pulumi.Input[Optional[str]]] = None,
                                                              organization_id: Optional[pulumi.Input[str]] = None,
                                                              per_page: Optional[pulumi.Input[Optional[int]]] = None,
                                                              search: Optional[pulumi.Input[Optional[str]]] = None,
                                                              starting_after: Optional[pulumi.Input[Optional[str]]] = None,
                                                              opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetInventoryOnboardingCloudMonitoringNetworksResult]:
    """
    ## Example Usage

    ```python
    import pulumi
    import pulumi_meraki as meraki

    example = meraki.organizations.get_inventory_onboarding_cloud_monitoring_networks(device_type="string",
        ending_before="string",
        organization_id="string",
        per_page=1,
        search="string",
        starting_after="string")
    pulumi.export("merakiOrganizationsInventoryOnboardingCloudMonitoringNetworksExample", example.items)
    ```


    :param str device_type: deviceType query parameter. Device Type switch or wireless controller
    :param str ending_before: endingBefore query parameter. A token used by the server to indicate the end of the page. Often this is a timestamp or an ID but it is not limited to those. This parameter should not be defined by client applications. The link for the first, last, prev, or next page in the HTTP Link header should define it.
    :param str organization_id: organizationId path parameter. Organization ID
    :param int per_page: perPage query parameter. The number of entries per page returned. Acceptable range is 3 100000. Default is 1000.
    :param str search: search query parameter. Optional parameter to search on network name
    :param str starting_after: startingAfter query parameter. A token used by the server to indicate the start of the page. Often this is a timestamp or an ID but it is not limited to those. This parameter should not be defined by client applications. The link for the first, last, prev, or next page in the HTTP Link header should define it.
    """
    __args__ = dict()
    __args__['deviceType'] = device_type
    __args__['endingBefore'] = ending_before
    __args__['organizationId'] = organization_id
    __args__['perPage'] = per_page
    __args__['search'] = search
    __args__['startingAfter'] = starting_after
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('meraki:organizations/getInventoryOnboardingCloudMonitoringNetworks:getInventoryOnboardingCloudMonitoringNetworks', __args__, opts=opts, typ=GetInventoryOnboardingCloudMonitoringNetworksResult)
    return __ret__.apply(lambda __response__: GetInventoryOnboardingCloudMonitoringNetworksResult(
        device_type=pulumi.get(__response__, 'device_type'),
        ending_before=pulumi.get(__response__, 'ending_before'),
        id=pulumi.get(__response__, 'id'),
        items=pulumi.get(__response__, 'items'),
        organization_id=pulumi.get(__response__, 'organization_id'),
        per_page=pulumi.get(__response__, 'per_page'),
        search=pulumi.get(__response__, 'search'),
        starting_after=pulumi.get(__response__, 'starting_after')))
